
# Optimization that only processes a select number of entities at a time
# This could cause some weapon effects to fail, esp when many entities loaded
# Without it however, there is a chance all commands will simultaneously freeze, breaking the world 
execute unless entity @e[family=speedsilver:mob,tag=!processed]                                     run tag @e remove processed
tag @e[family=speedsilver:mob,tag=!processed,c=100] add temp.process
tag @a add temp.process



execute as @e[tag=despawn] at @s                                                                    run event entity @s speedsilver:despawn

execute as @e[family=speedsilver:mob,tag=temp.process] at @s                                        run function entity/health/main

# reset attack trigger set by controllers
tag @e remove is.attacking

execute as @e[tag=is.damaged,tag=temp.process]                                                      run tag @s add temp.entity.damaged
execute as @e[tag=is.damaged.fatal,tag=temp.process]                                                run tag @s add temp.entity.damaged
execute as @e[scores={cd.damaged=0..},tag=temp.process]                                             run tag @s add temp.entity.damaged
execute as @e[tag=temp.entity.damaged,tag=temp.process] at @s                                       run function entity/damaged/main
execute as @e[tag=!temp.entity.damaged,tag=temp.process]                                            run function entity/damaged/clear.damaged
tag @e remove temp.entity.damaged

execute as @e[tag=is.damaging,tag=temp.process]                                                     run tag @s add temp.entity.damaging
execute as @e[scores={cd.damaging=0..},tag=temp.process]                                            run tag @s add temp.entity.damaging
execute as @e[tag=temp.entity.damaging,tag=temp.process] at @s                                      run function entity/damaging/main
tag @e remove temp.entity.damaging

execute as @e[tag=is.immune] unless score @s cd.immune matches 0.. at @s                            run function entity/immune/main
execute as @e[scores={cd.immune=0..}] at @s                                                         run function entity/immune/main

execute as @e[tag=is.knockback_proof] unless score @s cd.knock.proof matches 0.. at @s              run function entity/knockback_proof/main
execute as @e[scores={cd.knock.proof=0..}] at @s                                                    run function entity/knockback_proof/main

execute as @e[scores={cd.hypno.target=0..}] at @s                                                   run function item/hypnosis_staff/hypnosis/target/main
execute as @e[scores={cd.hypno.ctrl=0..}] at @s                                                     run function item/hypnosis_staff/hypnosis/controlled/main

execute if score second_10 clock matches 0                                                          run function entity/manage_ids
scoreboard players reset temp


tag @e[tag=temp.process] add processed
tag @e remove temp.process